# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without maven

%if %with maven
%bcond_without repolib
%else
%bcond_with repolib
%endif

%define base_name  codec
%global short_name commons-%{base_name}

%define section    free

%define reltag _redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           apache-commons-codec
Version:        1.4
Release:        9.1%{?reltag}%{?dist}.1
Epoch:          0
Summary:        Apache Commons Codec Package
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://commons.apache.org/codec/
Source0:        http://www.apache.org/dist/jakarta/commons/%{base_name}/source/%{short_name}-%{version}-src.tar.gz
Patch0:         commons-codec-pom.patch
Requires:       java >= 0:1.6.0
Obsoletes:      jakarta-%{short_name} <= %{epoch}:%{version}-%{release}
Provides:       jakarta-%{short_name} = %{epoch}:%{version}-%{release}
%if 0
Obsoletes:      %{short_name} <= %{epoch}:%{version}-%{release}
%endif
Provides:       %{short_name} = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  junit4
BuildRequires:  java-javadoc
%if %with maven
BuildRequires:  commons-parent >= 0:12
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
%else
BuildRequires:  ant
BuildRequires:  ant-junit
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Commons Codec is an attempt to provide definitive implementations of
commonly used encoders and decoders.

%package javadoc
Summary:        Javadoc for %{short_name}
Group:          Development/Documentation
Requires:       java-javadoc
Obsoletes:      jakarta-%{short_name}-javadoc <= %{epoch}:%{version}-%{release}
Provides:       jakarta-%{short_name}-javadoc = %{epoch}:%{version}-%{release}
%if 0
Obsoletes:      %{short_name}-javadoc <= %{epoch}:%{version}-%{release}
%endif
Provides:       %{short_name}-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
Javadoc for %{short_name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java
Provides:       jakarta-%{short_name}-repolib = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-repolib <= %{epoch}:%{version}-%{release}
Provides:       %{short_name}-repolib = %{epoch}:%{version}-%{release}
%if 0
Obsoletes:      %{short_name}-repolib <= %{epoch}:%{version}-%{release}
%endif

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{short_name}-%{version}-src
%patch0 -p1 -b .sav0

%{__sed} -i 's/\r//' LICENSE.txt NOTICE.txt RELEASE-NOTES*.txt TODO

%build
%if %with maven
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
%else
export CLASSPATH=`build-classpath junit4`
export OPT_JAR_LIST=`cat %{_sysconfdir}/ant.d/junit`
%{ant} -Dbuild.sysclasspath=first \
  -Dconf.home=src/conf \
  -Dbuild.home=build \
  -Dsource.home=src/java \
  -Dtest.home=src/test \
  -Ddist.home=dist \
  -Dcomponent.title=%{short_name} \
  -Dcomponent.version=%{namedversion} \
  -Dfinal.name=%{short_name}-%{namedversion} \
  -Dextension.name=%{short_name} \
  test jar javadoc
%endif

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
%if %with maven
cp -p target/%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
%else
cp -p dist/%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
%endif
ln -s %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}.jar
ln -s %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-%{short_name}-%{namedversion}.jar
ln -s jakarta-%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-%{short_name}.jar

# pom
mkdir -p %{buildroot}%{_mavenpomdir}
cp -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}.pom
%add_to_maven_depmap commons-codec commons-codec %{namedversion} JPP %{short_name}
[ -f %{buildroot}%{_mavendepmapfragdir}/%{short_name} ] || mv %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/%{short_name}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%if %with maven
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%else
cp -pr dist/docs/api/* %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%endif
ln -s %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/%{short_name}
ln -s %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}-%{namedversion}
ln -s jakarta-%{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}

# repolib
%if %with repolib
mkdir -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
cp -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt NOTICE.txt RELEASE-NOTES*.txt TODO
%{_javadir}*/%{short_name}-%{namedversion}.jar
%{_javadir}*/%{short_name}.jar
%{_javadir}*/jakarta-%{short_name}-%{namedversion}.jar
%{_javadir}*/jakarta-%{short_name}.jar
%{_mavenpomdir}/JPP-%{short_name}.pom
%{_mavendepmapfragdir}/%{short_name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{short_name}-%{namedversion}
%{_javadocdir}/%{short_name}
%{_javadocdir}/jakarta-%{short_name}-%{namedversion}
%{_javadocdir}/jakarta-%{short_name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.4-9.1_redhat_1.1
- Rebuild using cache signing

* Fri Feb 03 2012 David Walluck <dwalluck@redhat.com> 0:1.4-9.1
- many fixes for brew
- bump release due to jakarta-commons-codec

* Thu Dec 09 2010 Ralph Apel <r.apel@r-apel.de> 0:1.4-5
- Fix compat symlinks for jakarta-commons-codec

* Thu Oct 07 2010 Ralph Apel <r.apel@r-apel.de> 0:1.4-4
- Provide compat symlinks for jakarta-commons-codec

* Thu Sep 23 2010 Ralph Apel <r.apel@r-apel.de> 0:1.4-3
- Drop Requires for apache-commons-parent

* Wed Sep 08 2010 Ralph Apel <r.apel@r-apel.de> 0:1.4-2
- Add poms and depmap frags
- OK move to free

* Sun Nov 22 2009 Ralph Apel <r.apel@r-apel.de> 0:1.4-1
- 1.4
- rename to apache-commons-codec
- build with maven2 by default

* Fri May 30 2008 Permaine Cheung <pcheung@redhat.com> 0:1.3-9
- First JPP 5 build

* Wed Mar 21 2007 Matt Wringe <mwringe@redhat.com> 0:1.3-8jpp
- Fix some rpmlint warnings
- Update copyright year

* Tue Sep 26 2006 Matt Wringe <mwringe at redhat.com> 0:1.3-7jpp.1
- Add missing java-javadoc requires and buildrequires.

* Mon Sep 25 2006 Matt Wringe <mwringe at redhat.com> 0:1.3-6jpp
- Update jakarta-commons-codec-1.3-buildscript.patch to build
  offline.

* Thu Aug 10 2006 Matt Wringe <mwringe at redhat.com> 0:1.3-5jpp
- Add missing javadoc requires

* Thu Jul 20 2006 Matt Wringe <mwringe at redhat.com> 0:1.3-4jpp
- Added conditional native compiling

* Tue Apr 04 2006 Ralph Apel <r.apel@r-apel.de> 0:1.3-3jpp
- First JPP-1.7 release

* Thu May 05 2005 Fernando Nasser <fnasser@redhat.com> 0:1.3-2jpp_1rh
- First Red Hat build

* Wed Sep 08 2004 Fernando Nasser <fnasser@redhat.com> 0:1.3-2jpp
- Do not stop on test failure

* Tue Sep 07 2004 Fernando Nasser <fnasser@redhat.com> 0:1.3-1jpp
- Upgrade to 1.3
- Rebuilt with Ant 1.6.2

* Thu Jan 22 2004 David Walluck <david@anti-microsoft.org> 0:1.2-1jpp
- 1.2
- use perl instead of patch

* Wed May 28 2003 Ville Skytt <jpackage-discuss at zarb.org> - 0:1.1-1jpp
- First JPackage release.
